// mandelbrotView.cpp : CMandelbrotView NX̓̒`s܂B
//

#include "stdafx.h"

#include <math.h>
#include "mandelbrot.h"

#include "mandelbrotDoc.h"
#include "mandelbrotView.h"
#include "oorDlg.h"
#include "helpDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


typedef struct tagTHREADPARAMS{
  HWND hwnd;
  BOOL quit;
  double x1, y1, x2, y2, x_step, y_step;
  int    max;
  int    n_x, n_y;
  int    draw_type;
  int    colpat;
} THREADPARAMS;

THREADPARAMS m_thread;

CDC     memDC;
CBrush  memBrush;
CBitmap hbit;
int x_max = 0;

/////////////////////////////////////////////////////////////////////////////
// CMandelbrotView

IMPLEMENT_DYNCREATE(CMandelbrotView, CFormView)

BEGIN_MESSAGE_MAP(CMandelbrotView, CFormView)
	//{{AFX_MSG_MAP(CMandelbrotView)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_BN_CLICKED(IDC_NEWCOOR, OnNewcoor)
	ON_WM_LBUTTONDOWN()
	ON_BN_CLICKED(IDC_ORIG, OnOrig)
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_BN_CLICKED(IDC_ZOOMIN, OnZoomin)
	ON_BN_CLICKED(IDC_ZOOMOUT, OnZoomout)
	ON_COMMAND(ID_HALF, OnHalf)
	ON_COMMAND(ID_DOUBLE, OnDouble)
	ON_COMMAND(ID_COOR, OnCoor)
	ON_COMMAND(ID_IMG_ALL, OnImgAll)
	ON_WM_SETCURSOR()
	ON_CBN_SELCHANGE(IDC_TYPE, OnSelchangeType)
	ON_COMMAND(ID_COL0, OnCol0)
	ON_COMMAND(ID_COL1, OnCol1)
	ON_COMMAND(ID_COL2, OnCol2)
	ON_COMMAND(ID_COL3, OnCol3)
	ON_COMMAND(ID_COL5, OnCol5)
	ON_COMMAND(ID_COL4, OnCol4)
	ON_COMMAND(IDC_HELPMSG, OnHelpmsg)
	ON_COMMAND(ID_TB_HELP, OnTbHelp)
	ON_COMMAND(ID_STOP, OnStop)
	ON_UPDATE_COMMAND_UI(ID_COL0, OnUpdateCol0)
	ON_UPDATE_COMMAND_UI(ID_COL1, OnUpdateCol1)
	ON_UPDATE_COMMAND_UI(ID_COL2, OnUpdateCol2)
	ON_UPDATE_COMMAND_UI(ID_COL3, OnUpdateCol3)
	ON_UPDATE_COMMAND_UI(ID_COL4, OnUpdateCol4)
	ON_UPDATE_COMMAND_UI(ID_COL5, OnUpdateCol5)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMandelbrotView NX̍\z/

CMandelbrotView::CMandelbrotView()
	: CFormView(CMandelbrotView::IDD)
{
	//{{AFX_DATA_INIT(CMandelbrotView)
		// : ClassWizard ͂̈ʒuɃȍǉ܂B
	//}}AFX_DATA_INIT
	// TODO: ̏ꏊɍ\zp̃R[hǉĂB

}

CMandelbrotView::~CMandelbrotView()
{
}

void CMandelbrotView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMandelbrotView)
		// : ClassWizard ͂̈ʒu DDX  DDV ̌Ăяoǉ܂B
	//}}AFX_DATA_MAP
}

BOOL CMandelbrotView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB
  m_quit = FALSE;  
  loop_max = 20;
  m_enlarge = FALSE;
  //x1 = 0.2691; y1 = 0.0043;
  //x_step = y_step = 0.000002;

	return CFormView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMandelbrotView NX̐ff

#ifdef _DEBUG
void CMandelbrotView::AssertValid() const
{
	CFormView::AssertValid();
}

void CMandelbrotView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CMandelbrotDoc* CMandelbrotView::GetDocument() // fobO o[W̓CCłB
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMandelbrotDoc)));
	return (CMandelbrotDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMandelbrotView NX̃bZ[W nh
void CMandelbrotView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ

  CWnd *h = GetDlgItem(IDC_PICT);	
  CRect r;
  h->GetClientRect(r);
  n_x = r.right; n_y = r.bottom;
  x0 = -0.70; y0 = 0.0; x_band = 3.0;
  double y_band = x_band * n_y / n_x;
  x1 = x0 - x_band / 2; x2 = x1 + x_band;
  y1 = y0 - y_band / 2; y2 = y1 + y_band;

  colpat = 4;
  ((CComboBox *)(GetDlgItem(IDC_TYPE)))->SetCurSel(colpat);

  CDC *hDC;
  hDC=h->GetDC();
  memDC.CreateCompatibleDC(hDC);
  hbit.CreateCompatibleBitmap(hDC, n_x, n_y);
  SelectObject(memDC, hbit);
  memBrush.CreateSolidBrush(RGB(0, 0, 0));
  SelectObject(memDC, memBrush);
  h->ReleaseDC(hDC);

  OnOrig();
}

/*
void CMandelbrotView::OnQuit() 
{
  AfxGetMainWnd()->PostMessage(WM_CLOSE);
}
*/

UINT calc(LPVOID pParam) 
{
  THREADPARAMS *p = (THREADPARAMS *) pParam;
  CWnd *h = CWnd::FromHandle((HWND)p->hwnd);
  CPaintDC dc(h); 
  CDC *pDC = h->GetDC();

  int  i, j;
  int  val, val_red, val_green, val_blue;
  double x, y, a, b, a2, b2;
  double x1, y1, x2, y2, x_step, y_step;
  int  count, n_min = 50, n_max;
  int  n_x, n_y, colpat;

  x1 = p->x1; y1 = p->y1;
  x2 = p->x2; y2 = p->y2;
  n_x = p->n_x; n_y = p->n_y;
  n_max = p->max;  
  colpat = p->colpat;
  x_step = (x2 - x1) / n_x; y_step = (y2 - y1)/ n_y;

  COLORREF color;

  //AfxGetApp()->DoWaitCursor(1);  

  for (i = 0; i < n_x; i++){
    x = x1 + i * x_step;
    for (j = 0; j < n_y; j++){
      y = y1 + j * y_step;
      a = x; b = y; 
      a2 = a * a; b2 = b * b; count = 0;
      while ((a2 + b2 <= 4) && (count < n_max)){
        b = 2 * a * b + y; a = a2 - b2 + x;
        a2 = a * a; b2 = b * b; 
        count++;
        if (p->quit) {
          //delete p;  ȂAꂪƑʖڂȂ́H
          return 0;
        }
      }
     
      switch (colpat){
      case 0://
        val_red   = (count % 65) *  4;
        if (val_red >= 256) val_red = 255;
        val_green = val_red;
        val_blue  = val_red;
        color = RGB(val_red, val_green, val_blue);
        break;

      case 1: //n
        val = 64 * 64 * 64 * count / n_max;
        val_red   = (val / 4096) % 256;
        val_green = (val / 64) % 256;
        val_blue  = val % 256;
        color = RGB(val_red, val_green, val_blue);
        break;

      case 2: //256F\@ԗD
        if (count >= n_max) {
          color = 0;
        } else {
          val_red   = (count & 0x7) <<5;
          val_green = ((count >> 3) & 0x3) << 14;
          val_blue  = ((count >> 5) & 0x7) << 21;
          color = val_blue | val_green | val_red;
        }
        break;

      case 3: //256F\ D(R:3bit, G:2bit, B:3bit)
        if (count >= n_max) {
          color = 0;
        } else {
          val_red   = ((count >> 5) & 0x7) <<5;
          val_green = ((count >> 3) & 0x3) << 14;
          val_blue  = (count & 0x7) << 21;
          color = val_blue | val_green | val_red;
        }
        break;

      case 4: //WF\
        if (count >= n_max) {
          val_red = 0; val_green = 0; val_blue = 0;
        } else {
          val = count % 8;
          switch (val){
          case 0: val_red = 0; val_green = 0; val_blue = 0; break;
          case 1: val_red = 0; val_green = 0; val_blue = 255; break;
          case 2: val_red = 0; val_green = 255; val_blue = 0; break;
          case 3: val_red = 0; val_green = 255; val_blue = 255; break;
          case 4: val_red = 255; val_green = 0; val_blue = 0; break;
          case 5: val_red = 255; val_green = 0; val_blue = 255; break;
          case 6: val_red = 255; val_green = 255; val_blue = 0; break;
          case 7: val_red = 255; val_green = 255; val_blue = 255; break;
          }
        }
        color = RGB(val_red, val_green, val_blue);
        break;

      default: //WF\
        if (count >= n_max) {
          val_red = 0; val_green = 0; val_blue = 0;
        } else {
          val = (count / 10) % 8;
          switch (val){
          case 0: val_red = 0; val_green = 0; val_blue = 0; break;
          case 1: val_red = 0; val_green = 0; val_blue = 255; break;
          case 2: val_red = 0; val_green = 255; val_blue = 0; break;
          case 3: val_red = 0; val_green = 255; val_blue = 255; break;
          case 4: val_red = 255; val_green = 0; val_blue = 0; break;
          case 5: val_red = 255; val_green = 0; val_blue = 255; break;
          case 6: val_red = 255; val_green = 255; val_blue = 0; break;
          case 7: val_red = 255; val_green = 255; val_blue = 255; break;
          }
        }
        color = RGB(val_red, val_green, val_blue);
        break;
      }
      pDC->SetPixel(i, j, color);
      memDC.SetPixel(i, j, color);
    }
  }

  //AfxGetApp()->DoWaitCursor(0);  
  //delete p;
  return 0;
}

void CMandelbrotView::draw_start() 
{
  CStatusBar *sb = (CStatusBar *)AfxGetApp()->m_pMainWnd->
     GetDescendantWindow(AFX_IDW_STATUS_BAR);

  m_thread.quit = TRUE;	//ɕ`撆ȂΎ~߂B
  ::Sleep(50);

  char buf[80];
  sprintf(buf, "(%f,%f)-(%f,%f)",  x1, y1, x2, y2);
  sb->SetPaneText(0, buf);

  m_thread.hwnd = GetDlgItem(IDC_PICT)->m_hWnd;
	m_thread.quit = FALSE; //Vȕ`ɓB
  m_thread.x1 = x1;
  m_thread.y1 = y1;
  m_thread.x2 = x2;
  m_thread.y2 = y2;
  m_thread.max = loop_max;
  m_thread.n_x = n_x; 
  m_thread.n_y = n_y;
  m_thread.colpat = ((CComboBox *)(GetDlgItem(IDC_TYPE)))->GetCurSel();
  CWinThread *pThread = AfxBeginThread(calc, &m_thread);
}


void CMandelbrotView::OnStop() 
{
  m_thread.quit = TRUE;	
}

void CMandelbrotView::OnDraw(CDC* pDC) 
{
	CPaintDC dc(this); 
  CWnd *h = GetDlgItem(IDC_PICT);	
  CDC *ppDC = h->GetDC();
  CRect r;
  h->GetClientRect(r);

  ppDC->BitBlt(0, 0, r.right, r.bottom,  &memDC, 0, 0, SRCCOPY);

  h->ReleaseDC(ppDC);
}

//@VȍW̓͂󂯕tB
void CMandelbrotView::OnNewcoor() 
{
  CoorDlg dlg;
  int ret;
  double height;

  dlg.m_x0 = (x2 + x1) /2.0;
  dlg.m_y0 = (y1 + y2) /2.0;
  dlg.m_width = x2 - x1;
  ret = dlg.DoModal();
  if (ret == IDOK){
    x1 = dlg.m_x0 - dlg.m_width / 2.0;
    x2 = x1 + dlg.m_width;
    height = dlg.m_width * (((double) n_y)/ n_x);
    y2 = dlg.m_y0 + height / 2.0;
    y1 = dlg.m_y0 - height / 2.0;
    draw_start();
  }
}


//S̑\
void CMandelbrotView::OnOrig() 
{
  x0 = -0.70; y0 = 0.0; x_band = 3.0;
  double y_band = x_band * n_y / n_x;
  x1 = x0 - x_band / 2; x2 = x1 + x_band;
  y1 = y0 - y_band / 2; y2 = y1 + y_band;
  loop_max = 20;
  memDC.PatBlt(0, 0, n_x, n_y, PATCOPY);
  
  //`Jn
  draw_start();
}

void CMandelbrotView::OnLButtonDown(UINT nFlags, CPoint point) 
{
  int pox_adj; //ǧ݂␳̒l

  if (m_enlarge == FALSE){
    time_start = GetTickCount();

    m_enlarge = TRUE;
    pox_adj = point.x - ::GetSystemMetrics(SM_CXFIXEDFRAME);
    px0 = pox_adj;
    py0 = point.y;
    x1_new = (x2 - x1) / n_x * px0 + x1;
    y1_new = (y2 - y1) / n_y * py0 + y1;
    SetCapture();
  }

  CStatusBar *sb = (CStatusBar *)AfxGetApp()->m_pMainWnd->
     GetDescendantWindow(AFX_IDW_STATUS_BAR);
  char buf[80];
  sprintf(buf, "(%f,%f)", x1_new, y1_new);
  sb->SetPaneText(0, buf);

  if (pox_adj >= 0 && pox_adj <= n_x && 
    point.y >= 0 && point.y <= n_y){ 
    HCURSOR cur;
    cur = AfxGetApp()->LoadStandardCursor(IDC_CROSS);
    SetCursor(cur);
  }

 	CFormView::OnLButtonDown(nFlags, point);
}

void CMandelbrotView::OnLButtonUp(UINT nFlags, CPoint point) 
{
  CFormView::OnLButtonUp(nFlags, point);
  if (m_enlarge == FALSE) return;
  m_enlarge = FALSE;

  ReleaseCapture();	

  time_stop = GetTickCount();
  loop_max = 258;
  int pox_adj; //ǧ݂␳̒l
  pox_adj = point.x - (::GetSystemMetrics(SM_CXBORDER) +
                       ::GetSystemMetrics(SM_CXFIXEDFRAME));

  //}EXł̗̈Iɂ܂ɒZԂŃNbNꂽꍇ̑Ώ
  if ((time_stop - time_start) <= 200){
    int n = 10;
    double x_org, y_org;
    x_org = (x2 - x1) * pox_adj / n_x + x1;
    y_org = (y2 - y1) * point.y / n_y + y1;
    x1_new = x_org - (x2 - x1) / (n * 2);
    x2_new = x1_new + (x2 - x1) / n;
    y1_new = y_org - (y2 - y1) / (n * 2);
    y2_new = y1_new + (y2 - y1) / n;

    x1 = x1_new; y1 = y1_new;
    x2 = x2_new; y2 = y2_new;
  }  else {
    px1 = pox_adj;
    py1 = point.y;
    x2_new = (x2 - x1) * px1 / n_x + x1;
    x_band = x2_new - x1_new; 
    y2_new = x_band * n_y / n_x  + y1_new;

    x1 = x1_new; y1 = y1_new;
    x2 = x2_new; y2 = y2_new;

    CStatusBar *sb = (CStatusBar *)AfxGetApp()->m_pMainWnd->
       GetDescendantWindow(AFX_IDW_STATUS_BAR);
    char buf[80];
    sprintf(buf, "(%f,%f)-(%f,%f)", x1, y1,  x2, y2);
    sb->SetPaneText(0, buf);

    CWnd *h = GetDlgItem(IDC_PICT);	
    CRect r;
    h->GetClientRect(r);

    CDC *ppDC = h->GetDC();
    int width = (pox_adj - px0) * n_y / n_x;
    double coeff = ((double)(n_x)) / (pox_adj - px0);
    int    ww = px1 - px0;
    int    hh = ww * n_y / n_x;
    ppDC->StretchBlt(0,  0, n_x, n_y, &memDC, 
                   px0, py0, ww, hh, SRCCOPY);
    h->ReleaseDC(ppDC);
  }
  draw_start();
}

void CMandelbrotView::OnMouseMove(UINT nFlags, CPoint point) 
{
  int pox_adj; //ǧ݂␳̒l

	if (m_enlarge == FALSE) return;

  pox_adj = point.x - (::GetSystemMetrics(SM_CXFIXEDFRAME) );

  CWnd *h = GetDlgItem(IDC_PICT);	
  CRect r;
  h->GetClientRect(r);

	CFormView::OnMouseMove(nFlags, point);

  CDC *ppDC = h->GetDC();

  int ww = pox_adj - px0; //point.x - px0;
  int hh = ww * n_y / n_x;

  if (pox_adj >= px0){
    ppDC->BitBlt(px0,  py0,
                 ww, hh,  &memDC, 
                 px0, py0, NOTSRCCOPY);
  }
  if (pox_adj >= x_max) x_max = pox_adj;
  else if (pox_adj >= px0){
    //}EXtɖ߂ꂽꍇA߂ꂽ̑Ï̐F߂B
    int www = x_max - point.x;
    ppDC->BitBlt(point.x, py0,
               www, hh,  &memDC, 
               point.x, py0, SRCCOPY);
    int hhh = (x_max - px0)* n_y / n_x;
    ppDC->BitBlt(px0, py0 + hh, 
                 x_max - px0, hhh, &memDC,
                 px0, py0 + hh, SRCCOPY);
    x_max = pox_adj;
  }

  h->ReleaseDC(ppDC);

  //Xe[^Xo[ɑÏ̍W\
  CStatusBar *sb = (CStatusBar *)AfxGetApp()->m_pMainWnd->
     GetDescendantWindow(AFX_IDW_STATUS_BAR);
  char buf[80];
  x2_new = (x2 - x1) * pox_adj / n_x + x1;
  y2_new = (x2_new - x1_new) * n_y / n_x  + y1_new;
  sprintf(buf, "(%f,%f)-(%f,%f)",  x1_new, y1_new, x2_new, y2_new);
  sb->SetPaneText(0, buf);
}

void CMandelbrotView::OnZoomin() 
{
  CWnd *h = GetDlgItem(IDC_PICT);	
  CRect r;
  h->GetClientRect(r);

  CDC *ppDC = h->GetDC();
  double x_band = x2 - x1;
  double y_band = y2 - y1;
  x1 = x1 + x_band / 4; x2 = x2 - x_band / 4;
  y1 = y1 + y_band / 4; y2 = y2 - y_band / 4;
  
  ppDC->StretchBlt(0,  0, n_x, n_y, &memDC, 
                   n_x / 4, n_y / 4, n_x / 2, n_y / 2, SRCCOPY);
  h->ReleaseDC(ppDC);
  draw_start();
}

void CMandelbrotView::OnZoomout() 
{
  CWnd *h = GetDlgItem(IDC_PICT);	
  CRect r;
  h->GetClientRect(r);

  CDC *ppDC = h->GetDC();
  double x_band = x2 - x1;
  double y_band = y2 - y1;
  x1 = x1 - x_band / 2; x2 = x2 + x_band / 2;
  y1 = y1 - y_band / 2; y2 = y2 + y_band / 2;

  ppDC->StretchBlt(n_x / 4,  n_y / 4, n_x / 2, n_y / 2, &memDC, 
                   0, 0,  n_x, n_y, SRCCOPY);

  h->ReleaseDC(ppDC);
  draw_start();
}

void CMandelbrotView::OnHalf() 
{
  OnZoomout();
}

void CMandelbrotView::OnDouble() 
{
  OnZoomin();
}

void CMandelbrotView::OnCoor() 
{
  OnNewcoor();
}

void CMandelbrotView::OnImgAll() 
{
  OnOrig();
}

BOOL CMandelbrotView::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
  //WM_SETCURSOR bZ[Wnh[gēRg[
  //J[\̌`ωB
  const char *nID;

  switch (pWnd->GetDlgCtrlID()){   // (1)
  case IDC_PICT: nID = IDC_CROSS; break;
  default:
    nID = IDC_ARROW; break;
  }
  SetCursor(AfxGetApp()->LoadStandardCursor(nID));  //(2)
  return TRUE;

	//return CFormView::OnSetCursor(pWnd, nHitTest, message);
}

void CMandelbrotView::OnSelchangeType() 
{
  colpat = ((CComboBox *)(GetDlgItem(IDC_TYPE)))->GetCurSel();
  draw_start();	
}


//͉̂AȂBR{{bNXł̐FIj[̃`FbN
//ɔf邽߂ɗpӂÃR{{bNXZNg̃R[obN
//֐ OnSelchangeTyep()@ŎIɃj[̃`FbN}[NXVB
void CMandelbrotView::update_col_menu(void)
{
  /*
  CMenu *menu = GetMenu();
  if (colpat ==  0) menu->CheckMenuItem(ID_COL0, MF_CHECKED);//MF_CHECKED MF_UNCHECKED ;
  else menu->CheckMenuItem(ID_COL0, MF_UNCHECKED);
  */
}

void CMandelbrotView::OnCol0() 
{
  colpat = 0;
  ((CComboBox *)(GetDlgItem(IDC_TYPE)))->SetCurSel(colpat);	
  draw_start();	
}

void CMandelbrotView::OnCol1() 
{
  colpat = 1;
  ((CComboBox *)(GetDlgItem(IDC_TYPE)))->SetCurSel(colpat);	
  draw_start();	
}

void CMandelbrotView::OnCol2() 
{
  colpat = 2;
  ((CComboBox *)(GetDlgItem(IDC_TYPE)))->SetCurSel(colpat);	
  draw_start();	
}

void CMandelbrotView::OnCol3() 
{
  colpat = 3;
  ((CComboBox *)(GetDlgItem(IDC_TYPE)))->SetCurSel(colpat);	
  draw_start();	
}

void CMandelbrotView::OnCol4() 
{
  colpat = 4;
  ((CComboBox *)(GetDlgItem(IDC_TYPE)))->SetCurSel(colpat);	
  draw_start();	
}

void CMandelbrotView::OnCol5() 
{
  colpat = 5;
  ((CComboBox *)(GetDlgItem(IDC_TYPE)))->SetCurSel(colpat);	
  draw_start();	
}


void CMandelbrotView::OnHelpmsg() 
{
  ChelpDlg *dlg;
  dlg = new ChelpDlg(this);
  if (dlg->GetSafeHwnd() == 0)
    dlg->Create();
  Invalidate();
}

void CMandelbrotView::OnTbHelp() 
{
  OnHelpmsg();
}

void CMandelbrotView::OnUpdateCol0(CCmdUI* pCmdUI) 
{
  pCmdUI->SetCheck(colpat == 0);
}

void CMandelbrotView::OnUpdateCol1(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
  pCmdUI->SetCheck(colpat == 1);	
}

void CMandelbrotView::OnUpdateCol2(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
  pCmdUI->SetCheck(colpat == 2);	
}

void CMandelbrotView::OnUpdateCol3(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
  pCmdUI->SetCheck(colpat == 3);	
}

void CMandelbrotView::OnUpdateCol4(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
  pCmdUI->SetCheck(colpat == 4);	
}

void CMandelbrotView::OnUpdateCol5(CCmdUI* pCmdUI) 
{
	// TODO: ̈ʒu command update UI nhp̃R[hǉĂ
  pCmdUI->SetCheck(colpat == 5);	
}
